package com.supwisdom.dlpay.api.domain;

import com.supwisdom.dlpay.framework.domain.TSubject;

import javax.persistence.*;

import java.sql.Timestamp;
import java.util.List;

import static javax.persistence.FetchType.LAZY;

@Entity
@Table(name = "TB_TRANSACTIONMAIN",
    indexes = {@Index(name = "transmain_accdate", columnList = "accdate"),
        @Index(name = "transmain_status", columnList = "status"),
        @Index(name = "transmain_outtrade", unique = true, columnList = "outid, outtradeno")})
public class TTransactionMain {
  @Id
  @Column(name = "refno", nullable = false, length = 32)
  private String refno;

  @Column(name = "accdate", nullable = false, length = 8)
  private String accdate;

  @Column(name = "person")
  private Boolean person = false;

  @Column(name = "shop")
  private Boolean shop = false;

  @Column(name = "subject")
  private Boolean subject = false;

  @Column(name = "status", length = 20)
  private String status = "none";

  @Column(name = "outtradeno", length = 60)
  private String outTradeNo = "";

  @Column(name = "outid", length = 60)
  private String outId;

  @Column(name = "create_time")
  private Timestamp createTime;

  @Column(name = "end_time")
  private Timestamp endTime;

  @Column(name = "reverse_flag", nullable = false, length = 10)
  private String reverseFlag = "none";

  @OneToOne(targetEntity = TPersondtl.class, fetch = LAZY, cascade = CascadeType.ALL)
  @JoinColumn(name = "refno", referencedColumnName = "refno")
  private TPersondtl personDtl;

  @OneToOne(targetEntity = TShopdtl.class, fetch = LAZY, cascade = CascadeType.ALL)
  @JoinColumn(name = "refno", referencedColumnName = "refno")
  private TShopdtl shopDtl;

  @OneToOne(targetEntity = TSubjectdtl.class, fetch = LAZY, cascade = CascadeType.ALL)
  @JoinColumn(name = "refno", referencedColumnName = "refno")
  private TSubjectdtl subjectDtl;

  @OneToMany(targetEntity = TDebitCreditDtl.class, fetch = LAZY, cascade = CascadeType.ALL)
  @JoinColumn(name = "refno", referencedColumnName = "refno")
  private List<TDebitCreditDtl> details;

  public String getRefno() {
    return refno;
  }

  public void setRefno(String refno) {
    this.refno = refno;
  }

  public String getAccdate() {
    return accdate;
  }

  public void setAccdate(String accdate) {
    this.accdate = accdate;
  }


  public Boolean getPerson() {
    return person;
  }

  public void setPerson(Boolean person) {
    this.person = person;
  }

  public Boolean getShop() {
    return shop;
  }

  public void setShop(Boolean shop) {
    this.shop = shop;
  }

  public Boolean getSubject() {
    return subject;
  }

  public void setSubject(Boolean subject) {
    this.subject = subject;
  }

  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public String getOutTradeNo() {
    return outTradeNo;
  }

  public void setOutTradeNo(String outTradeNo) {
    this.outTradeNo = outTradeNo;
  }

  public String getOutId() {
    return outId;
  }

  public void setOutId(String outId) {
    this.outId = outId;
  }

  public String getReverseFlag() {
    return reverseFlag;
  }

  public void setReverseFlag(String reverseFlag) {
    this.reverseFlag = reverseFlag;
  }

  public TPersondtl getPersonDtl() {
    return personDtl;
  }

  public TShopdtl getShopDtl() {
    return shopDtl;
  }

  public TSubjectdtl getSubjectDtl() {
    return subjectDtl;
  }

  public List<TDebitCreditDtl> getDetails() {
    return details;
  }

  public void setPersonDtl(TPersondtl personDtl) {
    this.personDtl = personDtl;
  }

  public void setShopDtl(TShopdtl shopDtl) {
    this.shopDtl = shopDtl;
  }

  public void setSubjectDtl(TSubjectdtl subjectDtl) {
    this.subjectDtl = subjectDtl;
  }

  public void setDetails(List<TDebitCreditDtl> details) {
    this.details = details;
  }

  public Timestamp getCreateTime() {
    return createTime;
  }

  public void setCreateTime(Timestamp createTime) {
    this.createTime = createTime;
  }

  public Timestamp getEndTime() {
    return endTime;
  }

  public void setEndTime(Timestamp endTime) {
    this.endTime = endTime;
  }
}
